require 'colorize'

class Object

    def what_the()
        system 'clear'
        if !File.file?("./zmem.txt")
            if !block_given?
                puts
                puts("Come on! Give me a block!".yellow)
                print("(Remember what you do with a ".blue)
                print(".each ".red)
                puts("loop..)".blue)
                puts
                File.open("./zmem.txt", 'w') { |file| file.write("mem=1") }      
            else
                puts("\nHow did this work?!".red)
                puts("Where is this coming from?\n".light_blue)
                yield("Found me!..\nYou can move on\n".yellow)
            end
        else
            if !block_given?
                content = File.read("./zmem.txt")
                content_arr = content.split('=')
                times = content_arr[1]
                if times == "1"
                    puts
                    puts("Really?! Still no block?! If you get it wrong again, I'll give you a hint..".yellow)
                    puts
                    File.open("./zmem.txt", 'w') { |file| file.write("mem=2") }  
                elsif times == "2"
                    puts
                    puts("Hmm, ok then.".light_blue)
                    puts("This is a method that takes a block.".yellow)
                    print("Blocks start with a ".light_blue)
                    print("do".red)
                    print(", and close with an ".light_blue)
                    print("end".red)
                    puts(".".light_blue)
                    puts
                    File.open("./zmem.txt", 'w') { |file| file.write("mem=3") } 
                elsif times == "3"
                    puts("\nAlso, blocks sometimes take a block argument, which will help you out during this challenge.\n".yellow)
                    File.open("./zmem.txt", 'w') { |file| file.write("mem=4") } 
                else  
                    puts
                    puts("If you are still getting this wrong, you need to slack someone!".red)
                    puts
                end
            else
                puts("\nHow did this work?!".red)
                puts("Where is this coming from?\n".light_blue)
                yield("Found me!..\nYou can move on!\n".yellow)
            end
        end
    end

end

class YieldSource

    def what_is_it()
        # system 'clear'
        if File.file?("./zmem.txt")
            File.delete("./zmem.txt")
        end
        if !block_given?
            system 'clear'
            puts("\nNot again!!".yellow)
            puts("Gimme a BLOCK!\n".red)
        else
            yield("\nWell done!\n\n".yellow + "This one just reinforces the last one.\nMove on to the next problem.\n".red)
        end
    end

    def yielder(num1, num2)
        if !block_given?
            system 'clear'
            puts("\nGrrrrrrrrrrrrrrrr!\n".magenta)
        else
            puts("\nBefore the yield..\n".light_blue)
            result = num1 ** num2
            yield(result)
            puts("\n..after the yield.\n".light_blue)
        end
    end

    def how_many(str)
        e_count = 0
        str_arr = str.downcase.split('')
        str_arr.each do |letter|
            if letter == 'e'
                e_count += 1
            end
        end
        yield("\n\t#{e_count}\n".green)
    end

    def what_is_it_this_time(str)
        s_split = str.split('s')
        num_arr = []
        s_split.each do |sub_str|
            num_arr << sub_str.length
        end
        num_arr.each do |num|
            yield("\t#{num}".red)
        end
    end

    def argsss(str)
        space_split = str.split(' ')
        num_arr = []
        space_split.each do |sub_str|
            num_arr << sub_str.length
        end
        yield(*num_arr)
    end

    def now_what(arr)
        if arr.length % 3 == 0
            yield(true)
        else 
            yield(false)
        end
    end 
    
    def str_to_what(sentence)
        str_parts = sentence.split(' ')
        counter = 0
        output_hash = {}
        while counter < str_parts.length
            output_hash[str_parts[counter].downcase.to_sym] = str_parts[counter+1]
            counter += 2
        end
        yield(output_hash)
    end

    # More examples with the block returning something
    # Adjust to whether they have given a block.
end

# what_the() do |x|
#     puts x
# end

yield_obj = YieldSource.new()

# yield_obj.what_is_it() do |ahh|
#     puts ahh
# end

# yield_obj.yielder(2, 7) do |b|
#     puts b
# end

# yield_obj.how_many("jjjpppp") do |j|
#     puts j 
# end

# yield_obj.what_is_it_this_time("kjsldddsssldlswwwwwww") do |w, k|
#     puts w 
# end

# yield_obj.argsss("What is this?") do |o,j,m|
#     puts o, j, m
# end